import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class DoodleCanvas extends JComponent implements MouseListener, MouseMotionListener {
    public DoodleCanvas() {
        addMouseListener(this);
	addMouseMotionListener(this);
	
	setBorder(BorderFactory.createLineBorder(Color.black));
	setPreferredSize(new Dimension(100,100));
    }

    public String2D getString() {
        return theString;
    }

    public void setString(String2D string) {
        theString = string;
	repaint();
    }

    public void mousePressed(MouseEvent e) {
        if (!isEnabled())
	    return;

        theString = new String2D(e.getPoint());
	repaint();
    }

    public void mouseDragged(MouseEvent e) {
        if (!isEnabled())
	    return;

        theString.addLine(e.getPoint());
//	System.out.println("Size of string: " + theString.size());
	repaint();
    }

    protected void paintComponent(Graphics g) {
        super.paintComponent(g);

	g.setColor(getBackground());
	g.fillRect(0, 0, getSize().width, getSize().height);

	g.setColor(getForeground());
	if (theString != null)
	    theString.paint(g);
    }

    private String2D theString = null;
    
    public void mouseClicked(MouseEvent e) { }
    public void mouseEntered(MouseEvent e) { }
    public void mouseExited(MouseEvent e) { }
    public void mouseReleased(MouseEvent e)  { }
    public void mouseMoved(MouseEvent e)  { }
}
