import java.util.*;

class Sequence2D extends ArrayList<Edit2D> {

    public int cost() {
        int c = 0;
        Iterator<Edit2D> it = iterator();
	while (it.hasNext()) {
	    c += it.next().cost();
	}
	return c;
    }
    
    // get a (random) subsequence with cost approximately equal to 
    // alpha times the cost of this sequence where 0.0 <= alpha <= 1.0
    public Sequence2D getSubSequence(double alpha) {
	double counter = alpha;
        Sequence2D S = new Sequence2D();
        Iterator<Edit2D> it = iterator();
	while (it.hasNext()) {
	    Edit2D e = it.next();
	    if (counter >= 1.0 && Math.random() < alpha) {
	        counter -= 1.0;
                S.add(e); // chosen edit
	    } else {
	        // not chosen edits are replaced by 
		// dummy substitutions of cost = 0
		if (e.from != null)
	            S.add(new Edit2D(e.from, e.from));
	    }
	    counter += alpha;
	}
	return S;
    }

}
